#include <iostream>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>

int xmin, ymin;
int width, height;
float startx, starty;
float axis[3];
float theta;
float tx, ty;
float currentx, currenty;
int buttonPressed = 0;
float fov = 45.0;
float colorValues[6][3] = {{0, 0, 1}, {0, 1, 0}, {1, 0, 0}, {0, 1, 1}, {1, 1, 0}, {1, 0, 1}};
float matrix[16] = {1.0, 0.0, 0.0, 0.0,
		    0.0, 1.0, 0.0, 0.0, 
		    0.0, 0.0, 1.0, 0.0, 
		    0.0, 0.0, 0.0, 1.0};

void crossProduct(float res[3], float x[3], float y[3])
{
  // Je pense que vous pouvez coder une fonction produit vectoriel.
}


void drawObject()
{
  int i;
  float t1;
  float a1[3];
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(fov, (float)width/height, 0.001, 100);
  gluLookAt(0,0,-5,0,0,0,0,1,0);

  glMatrixMode(GL_MODELVIEW);  
  // Transformations a insrer ici
  glLineWidth(1.0);
  glPushMatrix();
  glColor3fv(colorValues[3]);
  glutWireTeapot(1.0);

  glLineWidth(5.0);
  glBegin(GL_LINES);
    glColor3fv(colorValues[2]);
    glVertex3f(0.0,0.0,0.0);
    glVertex3f(2.0,0.0,0.0);
    glColor3fv(colorValues[0]);
    glVertex3f(0.0,0.0,0.0);
    glVertex3f(0.0,2.0,0.0);
    glColor3fv(colorValues[1]);
    glVertex3f(0.0,0.0,0.0);
    glVertex3f(0.0,0.0,2.0);
  glEnd();
  glPopMatrix();
}

void
mouse(int button, int state, int x, int y)
{
  if (state == GLUT_DOWN) {
    startx = - 2.0*(float) (x-xmin)/(float) width + 1.0; 
    starty = 1.0 - 2.0*(float) (y-ymin)/(float) height ; 
    buttonPressed = button;
  } else {
    buttonPressed = -1;
  }
  glutPostRedisplay();
}

void 
motion(int x, int y)
{
  float start[3];
  float current[3];
  float r2;

  float cy =0;
  switch (buttonPressed) {
  case GLUT_LEFT_BUTTON:
    currentx = - 2.0*(float) (x-xmin)/(float) width + 1.0; 
    currenty = 1.0 - 2.0*(float) (y-ymin)/(float) height ; 
    // Transformation  calculer ici
    // une rotation.
    //
    break;
  case GLUT_MIDDLE_BUTTON:
    cy = 1.0 - 2.0*(float) (y-ymin)/(float) height ; 
    // Changement de l'angle de vue (fov)
    break;
  case GLUT_RIGHT_BUTTON:
    currentx = - 2.0*(float) (x-xmin)/(float) width + 1.0; 
    currenty = 1.0 - 2.0*(float) (y-ymin)/(float) height ; 
    // Transformation  calculer ici. 
    // une translation
    break;
  default:
    break;
  }
  glutPostRedisplay();
}

void printHelp()
{
  std::cout << "Virtual trackballs and field of view\n" << std::endl;
}

void parsekey(unsigned char key, int x, int y)
{
  switch (key)
    {
    case 27: exit(0);
    case ' ':
      fov = 45;
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void myReshape(int w, int h)
{
  xmin = 0;
  ymin = 0;
  if (w > h) {
    xmin = (w-h)/2;
    w = h;
  } else {
    ymin = (h-w)/2;
    h = w;
  }
  width = w;
  height = h;
  glViewport(xmin, ymin, w, h);
  glutPostRedisplay(); 
}

void display(void)
{
  glPushMatrix();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  drawObject();

  glutSwapBuffers();
  glPopMatrix();
}


int main(int argc, char *argv[]) 
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE | GLUT_STENCIL);
  glutCreateWindow("TD3 : Projection et rotation");
  glutDisplayFunc(display);
  glutInitWindowSize(1200, 1200);
  glutInitWindowPosition(200, 0);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(parsekey);
  glutReshapeFunc(myReshape);
  printHelp();

  glutSwapBuffers();
  glutMainLoop();
  return 0;
}
